#include <stdio.h>
#include <stdlib.h>
int main() 
{
    int N,Q;
	int i,q,m,dan;
	int u=0,t=0,p=0;
    scanf("%d %d",&N,&Q);
    int*dani=(int*)malloc(N*sizeof(int));            
    int*kolicine=(int*)malloc(N*sizeof(int));
    int*prestanci=(int*)calloc(Q,sizeof(int));
    for(i=0;i<N;i++)
	scanf("%d %d",&dani[i],&kolicine[i]);
    for(i=0;i<Q;i++)
    scanf("%d",&prestanci[i]);
    for(q=0;q<Q;q++)
	{
        m=prestanci[q];
        for(dan=1;dan<=m;++dan)
		{
            if (p<N && dan==dani[p]) 
			{
                t=t+kolicine[p];
                p++;
            }
            if(t > 0) 
			{
                u++;
                t--;
            }
            if(t == 0 && p >= N) 
			break;
        }
        printf("%d\n", u);
	}
    free(dani);
    free(kolicine);
    free(prestanci);
}